
n=100                                                                   ; points on curve
eps=1e-3                                                                ; accuracy
x=!pi/2.*findgen(n)/(n-1.)                                              ; x-scale

nit=10                                                                  ; max iterations
for i=0,nit-1 do begin
  plot,x,sin(x),xstyle=3,ystyle=3                                       ; plot function
  wshow
  y=randomu(seed)                                                       ; random y-value
  a=x[0]                                                                ; first point
  b=x[n-1]                                                              ; last point
  fa=sin(a)-y
  fb=sin(b)-y
  oplot,[x[0],x[n-1]],[y,y],line=2
  plots,a,sin(a),psym=6
  plots,b,sin(b),psym=6
  oplot,[b,b],[-1,2],line=1
  oplot,[a,a],[-1,2],line=1
  wait,1
  fa=sin(a)-y                                                           ; residue
  fb=sin(b)-y                                                           ; residue
  while abs(b-a) gt eps do begin
    c=(a+b)/2.                                                          ; midpoint
    fc=sin(c)-y
    plots,c,sin(c),psym=6
    oplot,[c,c],[-1,2],line=1
    wait,1
    if fc*fb gt 0 then begin                                            ; right signg?
       plots,b,sin(b),psym=6,color=0
       oplot,[b,b],[-1,2],line=1,color=0
       b=c                                                              ; replace b
       fb=fc
       plots,b,sin(b),psym=6
       oplot,[b,b],[-1,2],line=1
    end else begin
       plots,a,sin(a),psym=6,color=0
       oplot,[a,a],[-1,2],line=1,color=0
       a=c                                                              ; replace a
       fa=fc
       plots,a,sin(a),psym=6
       oplot,[a,a],[-1,2],line=1
    end
  end
  print,y,c,asin(y),c-asin(y)
end

END